program burbulas_mas;

const N = 9;

{ paprastas masyvas }
var mas,b,c : array [0..N] of integer;


{ paprasto masyvo inicializacija }
procedure inicializuoti_mas;
  var i : integer;
begin
  for i := 1 to N do mas[i] := 0
end;

{ skaiciaus paprastam masyve suradimas }
function rasti_mas (sk : integer) : boolean;
  var i : integer;
      b : boolean;
begin
  b := false;
  for i := 1 to N do
    if mas[i] = sk then
    begin
      b := true;
      break
    end;
  rasti_mas := b
end;

{ paprasto masyvo uzpildymas }
procedure uzpildyti_mas;
  var i, val : integer;
begin
  inicializuoti_mas ();
  randomize;
  for i := 1 to N do
  begin
    repeat
      val := 1 + random (99)
    until not rasti_mas(val);
    mas[i] := val
  end
end;

{ paprasto masyvo atspausdinimas }
procedure spausdinti_mas;
  var i : integer;
begin
  for i := 1 to N do write (' ', mas[i]);
  writeln
end;

 procedure spausdinti_mas2(mas:array of integer);
  var i : integer;
begin
  for i := 1 to N do write (' ', mas[i]);
  writeln
end;


procedure isrinkimas;
var i,j,min,t:integer;
begin
    for i :=1 to N-1 do
    begin
        min:=i;
        for j:=i+1 to N do
            if mas[j]<mas[min]
              then min:=j;
            t:=mas[min];
            mas[min]:=mas[i];
            mas[i]:=t;
    end;
end;

procedure iterpimas;
var i,j,v:integer;
begin
    for i:=2 to N do
    begin
        v:=mas[i];
        j:=i;
        while (mas[j-1]>v) do
        begin
            mas[j]:=mas[j-1];
            j:=j-1;
        end;
        mas[j]:=v;
    end;
end;


procedure selas;
label 0;
var i,j,h,v:integer;
begin
    h:=1;
    repeat h:=3*h+1 until h>N;
    repeat
    h:=h div 3;
    for i:=h+1 to N do
    begin
        v:=mas[i];
        j:=i;
        while mas[j-h]>v do
        begin
            mas[j]:=mas[j-h];
            j:=j-h;
            if j<=h then goto 0
        end;
        0:mas[j]:=v;
    end;
        until h=1;
end;

procedure quicksort(l,r:integer);
var v,t,i,j:integer;
begin
    if r>l then
    begin
        v:=mas[r];
        i:=l-1;
        j:=r;
        repeat
        repeat i:=i+1 until mas[i]>=v;
        repeat j:=j-1 until mas[j]<=v;
        t:= mas[i];
        mas[i]:=mas[j];
        mas[j]:=t;
        until j<=i;
        mas[j]:=mas[i];
        mas[i]:=mas[r];
        mas[r]:=t;
        quicksort(l,i-1);
        quicksort(i+1,r);
    end
end;

procedure mergesort(l,r:integer);
var i,j,k,m:integer;
begin
    if r-l>0 then
    begin
        m:=(r+l)div 2;
        mergesort(l,m);
        mergesort(m+1,r);
        for i :=m downto 1 do
        b[i]:=mas[i];
        for j:=m+1 to r do
        c[r+m+1-j]:=mas[j];
        for k:= l to r do
        begin
        if b[i]<c[j] then
        begin
            mas[k]:=b[i];
            i:=i+1;
        end
        else
        begin
            mas[k]:=c[j];
            j:=j-1;
        end;
        end;
    end
end;

{procedure radixexchange(l,r,b:integer);
    var t,i,j:integer;
begin
    if(r>l) and (b>=0) then
    begin
        i:= l;
        j:= r;
        repeat
        while(bits(mas[i],b,1)=0) and (i<j) do
            i:= i+1;
        while(bits(mas[i],b,1)=1) and (i<j) do
            j:=j-1;
        t:= mas[i];
        mas[i]:= mas[j];
        mas[j]:=t;
        until j=i;
        if bits(mas[r],b,1)=0 then
            j:=j+1;
        radixexchange(l,j-1,b-1);
        radixexchange(l,r,b-1);
    end
end;

procedure straightradix;
    var i,j,pas:integer;
        count: array[0..M] of integer;
begin
for pas:= 0 to (w div m)-1 do
    begin
    for j:=0 to M-1 do
    count[j]:=0;
    for i:= 1 to N do
    count[bits(mas[i],pass*m,m)]:=count[bits(mas[i],pas*m,m)]+1;
    for j:= 1 to M-1 do
    count[j]:=count[j-1]+count[j];
    for i:= N downto 1 do
    begin
        b[count[bits(mas[i],pass*m,m)]]:=mas[i];
        count[bits(mas[i],pass*m,m)]:= count[bits(mas[i],pass*m,m)]-1;
    end;
    for i:= 1 to N do
    mas[i]:= b[i];
    end;
end;
            
        
    }
    

begin
  writeln;
  writeln ('Pradedama programa...');
  writeln;
  writeln ('--- Paprastam masyvui didejanciai ---');
  uzpildyti_mas ();
  write ('Nerusiuotas:');
  spausdinti_mas ();
  mergesort(1,9);
  
  write ('Surusiuotas:');
  spausdinti_mas2 (b);
  spausdinti_mas2 (mas);
  
  readln
  
end.
